# Zongor's Universe Machine

The universe machine is a Virtual Machine that is intended to create 3D environments (Universes) for video games and/or generic 3d modeling jobs

It is inspired by [uxn](https://wiki.xxiivv.com/site/uxn.html), [var'aq](https://web.archive.org/web/20210913164515/https://www.oocities.org/connorbd/varaq/index.html), [TIS-100](https://www.zachtronics.com/tis-100/), [Inferno](https://www.inferno-os.org/), and [Plan9](https://plan9.io/plan9/).

The universe machine works as a series of stack based virtual cpu's (node) and ram as a simple hashmap (hram) that each have a single stack which are able to communicate with each other using message passing.

The machine code of this node is a series of stack operations which act on the individal node. each node has the ability to ask the kernel to spawn an additional node or to spawn a child node off of itself which sets up a couple of communication channels automatically.

The authors implementation of ZUM in written in C and uses the [SDL2](https://www.libsdl.org/) library to do drawing, sound, and other things.
